package com.sample;

import java.lang.reflect.Method;
import java.lang.reflect.Proxy;

public class MyProxy implements java.lang.reflect.InvocationHandler {
	private Object obj;

	private MyProxy(Object obj) {
		this.obj = obj;
	}

	public static Object create(Object obj) {
		Object proxy = Proxy.newProxyInstance(obj.getClass().getClassLoader(),
				obj.getClass().getInterfaces(), new MyProxy(obj));
		return proxy;
	}

	public Object invoke(Object proxy, Method method, Object[] args)
			throws Throwable {
		System.out.println("Invoking " + method + " with args " + args);
		return method.invoke(this.obj, args);
	}
}
